package mikroe.com.blepclick.BleLib;

import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothManager;
import android.bluetooth.BluetoothAdapter.LeScanCallback;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Handler;

public class BtManager {
	// Stops scanning after 10 seconds.
	private static final long SCAN_PERIOD = 10000;
	private Handler mHandler = new Handler();
	public boolean mScanning;
	private static BtManager mInstance;

	public BtManager() {

	}

	public static BtManager getInstance() {
		if (mInstance == null) {
			mInstance = new BtManager();
		}
		return mInstance;
	}

	public BluetoothAdapter getAdapter(Context context) {
		BluetoothManager bluetoothManager = (BluetoothManager) context
				.getSystemService(Context.BLUETOOTH_SERVICE);
		return bluetoothManager.getAdapter();
	}

	public void scanLeDevice(final BluetoothAdapter bluetoothAdapter,
			final LeScanCallback leScanCallback, final boolean enable) {
		if (enable) {
			// Stops scanning after a pre-defined scan period.
			mHandler.postDelayed(new Runnable() {
				@Override
				public void run() {
					mScanning = false;
					bluetoothAdapter.stopLeScan(leScanCallback);
				}
			}, SCAN_PERIOD);

			mScanning = true;
			bluetoothAdapter.startLeScan(leScanCallback);
		} else {
			mScanning = false;
			bluetoothAdapter.stopLeScan(leScanCallback);
		}
	}
	
	public void startBluetoothLeService(Context context, ServiceConnection serviceConnection)
	{
        Intent gattServiceIntent = new Intent(context, BluetoothLeService.class);
        context.bindService(gattServiceIntent, serviceConnection, Context.BIND_AUTO_CREATE);
	}

}